%define name openupload
%define version 0.4.2
%define release 11
%define httpuser apache

%if %{?fedora}%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: Share big files easily 
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
Distribution: SME Server
License: GNU GPL
URL: http://openupload.sourceforge.net/
Group: applications/internet
Source: %{name}-%{version}.tar.gz
Source1: httpd.conf
Source2: cleanup
Source3: cron
Patch1: openupload-0.4.1-imap_auth.patch
Patch2: openupload-0.4.1-charset_utf8_in_mail.patch
Patch3: openupload-0.4.2-http_auth_and_ldap.patch
Packager: Daniel B. <daniel@firewall-services.com>
BuildArch: noarch
BuildRoot: /var/tmp/%{name}-%{version}

Requires: php
Requires: httpd

%description
http://openupload.sourceforge.net/
Open Upload is an open source extensible PHP application
for fast file upload and download for big (and small) file
sharing, like rapidshare and megaupload.
Multiple authentication methods, database backends,
multilanguage support.

%prep
%setup
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
# empty build

%install

%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}
for a in $(find ./ -mindepth 1 -maxdepth 1 -type d -print); do
    cp -r $a %{buildroot}/%{_datadir}/%{name}/
done
cp *.php %{buildroot}/%{_datadir}/%{name}/

%{__mkdir} -p %{buildroot}/%{_localstatedir}/lib/%{name}
%{__mv} data/* %{buildroot}/%{_localstatedir}/lib/%{name}

sed -i -e "s|/usr/local/share/openupload|%{_datadir}/%{name}/|g" \
       -e "s|\$CONFIG\['INSTALL_ROOT'\].'/data'|'%{_localstatedir}/lib/%{name}'|" \
       %{buildroot}/%{_datadir}/%{name}/www/config.inc.php.example

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/httpd/conf.d/
%{__install} -m 0640 %{SOURCE1} %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}/bin
%{__install} -m 0755 %{SOURCE2} %{buildroot}/%{_datadir}/%{name}/bin/cleanup.php

%{__mkdir} -p %{buildroot}/%{_localstatedir}/log/
touch %{buildroot}/%{_localstatedir}/log/%{name}.log

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/cron.d
%{__install} -m 0644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/cron.d/%{name}
sed -i -e 's/__APACHE__/%{httpuser}/g' %{buildroot}/%{_sysconfdir}/cron.d/%{name}

%clean
rm -rf %{buildroot}

%post
%if %{useselinux}
(
# New File context
semanage fcontext -a -s system_u -t httpd_log_t           -r s0 "%{_localstatedir}/log/%{name}.log"
# keep httpd_sys_script_rw_t (httpd_var_lib_t prevent dir creation)
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/lib/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_datadir}/%{name}/templates_c(/.*)?"
# files created by app
restorecon -R %{_sysconfdir}/%{name}
restorecon -R %{_localstatedir}/lib/%{name}
restorecon -R %{_datadir}/%{name}/templates_c
restorecon -R %{_localstatedir}/log/%{name}.log
) &>/dev/null
%endif


%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/log/%{name}.log"
    semanage fcontext -d "%{_localstatedir}/lib/%{name}(/.*)?"
    semanage fcontext -d "%{_datadir}/%{name}/templates_c(/.*)?"
    ) &>/dev/null
fi
%endif


%files
%defattr(-,root,root)
%doc README LICENSE INSTALL TODO CHANGELOG
%{_datadir}/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/tmp
%dir %attr(775,root,%{httpuser}) %{_datadir}/%{name}/templates_c
%attr(660,root,%{httpuser}) %{_localstatedir}/log/%{name}.log
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%config(noreplace) %{_sysconfdir}/cron.d/%{name}


%changelog
* Wed Jul 27 2011 Daniel B. <daniel@firewall-services.com> - 0.4.2-11
- Fix cleanup script, also removed grouped files

* Mon Jul 04 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-10
- Don't restart apache on install/remove/upgrade

* Fri Mar 18 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-9
- Minor fix in httpldap patch

* Thu Feb 17 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-8
- cleanup httpldap patch

* Wed Jan 05 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-7
- Fix a redirect loop when using HTTP auth

* Thu Jan 04 2011 Daniel B. <daniel@firewall-services.com> 0.4.2-6
- Add patch to support HTTP auth, with a new auth module to
  retrieve user info via LDAP

* Tue Nov 23 2010 Daniel B. <daniel@firewall-services.com> 0.4.2-5
- Upstream upgrade to 0.4.2 (security fix)

* Wed Aug 05 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-5
- Fixe SELinux security context for templates_c dir
- Add Charset: UTF-8 in mail header

* Tue Mar 23 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-4
- Fixe apache user on el
- Add SELinux security contexts

* Mon Mar 22 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-3
- Fixes in apache config
- Update config.inc.php.example to point data dir to /var/lib/openupload

* Thu Mar 11 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-2
- update apache config

* Tue Mar 09 2010 Daniel B. <daniel@firewall-services.com> 0.4.1-1
- initial release
- include patch to support IMAP auth
- include cron job to cleanup expired files

